Bug 40965 - Uninitialised jk_ws_service_t fields prevent AJP13 connection reuse and cause flushing
Uninitialised jk_ws_service_t fields prevent AJP13 connection reuse and cause...
Status: CLOSED FIXED
Product: Tomcat Connectors
Classification: Unclassified
Component: Common
unspecified
PC Windows XP
: P2 critical (vote)
: ---
Assigned To: Tomcat Developers Mailing List
:
Depends on:
Blocks:
  Show dependency tree
 
Reported: 2006-11-13 16:33 UTC by Tim Whittington
Modified: 2008-10-05 03:09 UTC (History)
0 users



Attachments
Patch to correctly initialise jk_ws_service_t within the ISAPI redirector init_ws_service (1.03 KB, patch)
2006-11-13 16:35 UTC, Tim Whittington
Details | Diff

Note You need to log in before you can comment on or make changes to this bug.
Description Tim Whittington 2006-11-13 16:33:58 UTC
Several flags have in recent times been added to ajp_common.c, with
initialisation code in mod_jk:
- disable_reuse
- flush_headers
- flush_packets

These were not initialised in the IIS connector, and thus when they were
checked, uninitialised memory was being accessed, with the result that they were
all evaluated as being set.

This results in AJP13 connections between the connector and Tomcat not being
reused, and every header and packet write causing a flush. i.e. we're back in
the AJP12 days.

I've attached a patch to correct this, with an attempt at a check to ensure it
doesn't accidentally get broken again - I'd be open to other ways of achieving
this (e.g. documenting the jk_ws_service_t definition or a shared default
initialiser).
Comment 1 Tim Whittington 2006-11-13 16:35:52 UTC
Created attachment 19120 [details]
Patch to correctly initialise jk_ws_service_t within the ISAPI redirector init_ws_service
Comment 2 Mladen Turk 2006-11-14 08:05:39 UTC
Commited without the test for the sizeof(struct).
Thanks.
Comment 3 Rainer Jung 2008-01-01 16:51:29 UTC
Move a couple of fixed JK issues from resolved to closed.